#ifndef lint
#ifdef sccs
static char     sccsid[] = "@(#)XSunIMMthd.h	1.10 93/02/21 SMI";
#endif
#endif

/******************************************************************

              Copyright 1990, 1991, 1992 by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and
that both that copyright notice and this permission notice appear
in supporting documentation, and that the name of Sun Microsystems, Inc.
not be used in advertising or publicity pertaining to distribution
of the software without specific, written prior permission.
Sun Microsystems, Inc. makes no representations about the suitability of
this software for any purpose.  It is provided "as is" without
express or implied warranty.

Sun Microsystems Inc. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
IN NO EVENT SHALL Sun Microsystems, Inc. BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

  Author: Hideki Hiura (hhiura@Sun.COM)
	  				     Sun Microsystems, Inc.
******************************************************************/

#ifndef  XSUNIMMTHD_H
#define  XSUNIMMTHD_H

typedef struct _iml_methods {
    /*
     * drawing methods
     */
    iml_inst *	   (*iml_make_preedit_start_inst)();
    iml_inst *	   (*iml_make_preedit_draw_inst)();
    iml_inst *	   (*iml_make_preedit_erase_inst)();
    iml_inst *	   (*iml_make_preedit_caret_inst)();
    iml_inst *	   (*iml_make_preedit_done_inst)();
    iml_inst *	   (*iml_make_status_start_inst)();
    iml_inst *	   (*iml_make_status_draw_inst)();
    iml_inst *	   (*iml_make_status_done_inst)();
    iml_inst *	   (*iml_make_lookup_start_inst)();
    iml_inst *	   (*iml_make_lookup_draw_inst)();
    iml_inst *	   (*iml_make_lookup_process_inst)();
    iml_inst *	   (*iml_make_lookup_done_inst)();
    /*
     * 
     */
    iml_inst *	   (*iml_make_status_notify_inst)();
    iml_inst *	   (*iml_make_nop_inst)();
    iml_inst *	   (*iml_make_commit_inst)(/* iml_inst *s, int l, char *mbcs */);
    iml_inst *     (*iml_make_keypress_inst)();
    iml_inst *     (*iml_make_reset_return_inst)(/* iml_inst *s, int l, char *mbcs */);
    iml_inst *     (*iml_execute)();
    /*
     * convenient methods
     */
    int		   (*iml_lookupString)();
    iml_inst  	  *(*iml_link_inst_tail)();
    void	   (*iml_destruct_session)();
    void          *(*iml_construct_session)();/* actual return value is iml_session_t* */
} iml_methods_t ;
/*
 * NOTE:
 * iml_methods $@$O!"(Js->If->m $@$GD>@\;2>H$G$-$k$N$G(J override $@$O!"(J
 * register $@4X?t$r;H$o$:!"D>@\$*$3$J$&!#(J
 */

typedef struct _if_methods {
    Bool                (*if_OpenIF)(/* iml_if_t *If */);
    Bool                (*if_CloseIF)(/* nothing */);
    Bool                (*if_GetIFValue)(/* char *attr, void *value */);
    Bool                (*if_SetIFValue)(/* char *attr, void *value */);
    void               *(*if_CreateSC)(/* nothing */); /* actual return value is iml_session_t* */
    Bool                (*if_DestroySC)(/* iml_session_t *s */);
    Bool                (*if_SetSCValue)(/* iml_session_t *s, char *attr, void *value */ );
    Bool                (*if_GetSCValue)(/* iml_session_t *s, char *attr, void *value */ );
    char               *(*if_ResetSC)(/* iml_session_t *s */);
    void                (*if_SetSCFocus)(/* iml_session_t *s */);
    void                (*if_UnsetSCFocus)(/* iml_session_t *s */);
    void                (*if_SendEvent)(/* iml_session_t *s , XEvent *e */);
    Bool                (*if_FilterEvent)(/* XEvent *e */);
} if_methods_t ;
/*
 * NOTE:
 * if_*Value() $@4X?t$O!"$=$NL>$NDL$j!"0l2s$K0l$D$N(J value $@$7$+(J
 * get/set $@$G$-$J$$(J
 */

/*
 * Per interface data structure
 */
typedef struct _iml_if_t {
    int               ref_count ; 
    struct _iml_if_t *next ;
    void             *im ; /* should be casted to im_t */
    char             *if_name ;
    char             *if_version ;
    char             *locale ;
    if_methods_t     *ifm ;
    iml_methods_t    *m ;
    void             *if_spec ; /* pointer to the interface specific data */
} iml_if_t ;
/*
 * XXXXXXX For backword source compatibility.
 */
#define _iml_make_preedit_start_inst(a)      s->if->m->iml_make_preedit_start_inst(a)
#define _iml_make_preedit_draw_inst()        s->if->m->iml_make_preedit_draw_inst()
#define _iml_make_preedit_erase_inst(a)      s->if->m->iml_make_preedit_erase_inst(a)
#define _iml_make_preedit_caret_inst(a)      s->if->m->iml_make_preedit_caret_inst(a)
#define _iml_make_preedit_done_inst(a)       s->if->m->iml_make_preedit_done_inst(a)
#define _iml_make_status_start_inst(a)       s->if->m->iml_make_status_start_inst(a)
#define _iml_make_status_draw_inst()         s->if->m->iml_make_status_draw_inst()
#define _iml_make_status_caret_inst()        s->if->m->iml_make_status_caret_inst()
#define _iml_make_status_done_inst(a)        s->if->m->iml_make_status_done_inst()
#define _iml_make_lookup_start_inst(a)       s->if->m->iml_make_lookup_start_inst(a)
#define _iml_make_lookup_draw_inst()         s->if->m->iml_make_lookup_draw_inst()
#define _iml_make_lookup_process_inst(a,b,c) s->if->m->iml_make_lookup_process_inst(a,b,c)
#define _iml_make_lookup_done_inst(a)        s->if->m->iml_make_lookup_done_inst(a)
#define _iml_make_set_status_inst(a)         s->if->m->iml_make_status_notify_inst(a)
#define _iml_make_nop_inst(a)                s->if->m->iml_make_nop_inst(a)
#define _iml_make_commit_inst(a)             s->if->m->iml_make_commit_inst(a)
#define _iml_get_session(a)                  s->if->m->iml_get_session(a)
#define _iml_lookupKanaString(a,b,c,d)       s->if->m->iml_lookupKanaString(a,b,c,d)
#define _iml_link_inst_tail(a,b)             s->if->m->iml_link_inst_tail(a,b)
#define _iml_destruct_session(a,b,c)         s->if->m->iml_destruct_session(a,b,c)

/*
 * if_GetIFValue()/if_SetIFValue() attributes
 */
#define IF_VERSION "if_version"
#define IF_LE_NAME "if_le_name"
/*
 * if_GetSCValue()/if_SetSCValue() attributes
 */
#define SC_STATUS "sc_status"
#define SC_Henkan_Mode "sc_henkan_mode"
#define SC_MODIFIER_MASK "modifier_mask"

#define	SC_Lookup_info	"sc_lookup_info"
#define SC_lookup_imscontrol	"sc_lookup_imscontrol"
#define	SC_lookup_root		"sc_lookup_root"
#define SC_lookup_whoownslabel	"sc_lookup_whoownslabel"
#define	SC_lookup_labeltype	"sc_lookup_labeltype"
#define	SC_lookup_nchoices	"sc_lookup_nchoices"
#define	SC_lookup_rootwidth	"sc_lookup_rootwidth"
#define	SC_lookup_lines		"sc_lookup_nlines"
#define	SC_lookup_ewidth	"sc_lookup_ewidth"
#define	SC_lookup_cwidth	"sc_lookup_cwidth"
#define	SC_lookup_ncols		"sc_lookup_ncols"
#define	SC_lookup_nrows		"sc_lookup_nrows"
#define SC_lookup_direction	"sc_lookup_direction"
#define	SC_nego_flush		"sc_nego_flush"
#define SC_nego_data		"sc_nego_data"

#endif  /*  XSUNIMMTHD_H */
